<?php
/**
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */

require_once 'Customer.class.php';

final class CustomerFactory {
	
	private $users = array();
	private $userNameToID = array();
	private $userObjects = null;
	private $DB = null;
	static private $object = null;
		
	private function __construct() {
		$this->DB =& OpenVCP::call('DB', 'getReference');
		$userList = $this->DB->select($this->DB->table_user);
		foreach($userList as $user) {
			$this->users[$user['id']] = $user;
			$this->userNameToID[$user['loginname']] = $user['id'];
		}
	}
	
	static public function getInstance() {
		if(!isset(self::$object)) {
			self::$object = new CustomerFactory();
		}
		return self::$object;
	}
	
	public function getUserByName($username) {
		return $this->_getCustomer($this->userNameToID[$username]);
	}
	
	public function getUserByID($id) {
		return $this->_getCustomer($id);
	}
	
	private function _getCustomer($id) {
		if($this->userObjects[$id] == null) {
			$this->userObjects[$id] = new Customer($this->users[$id]);
		}
		return $this->userObjects[$id];
	}
	
}
?>