<?php

require_once('NodeFactory.class.php');


class NodeHandler {
	
	function getLoad($nodename) {
		ob_start();
		$load = NodeFactory::getNodeFactory()->getNodeByName($nodename)->getLoad(true);
		ob_end_clean();
		return $load;
	}
	
	function getUptime($nodename) {
		ob_start();
		$uptime = NodeFactory::getNodeFactory()->getNodeByName($nodename)->getUptime(true);
		ob_end_clean();
		return $uptime;
	}
	
	function getVersion($nodename) {
		ob_start();
		$version = NodeFactory::getNodeFactory()->getNodeByName($nodename)->getVersion();
		ob_end_clean();
				
		$script = "var element = document.getElementById('".$nodename."_daemon_version').innerHTML = '".$version[0]." ".$version[1]."';\n";
		$script .= "var element = document.getElementById('".$nodename."_kernel_version').innerHTML = '".$version[2]."';\n";
		$script .= "var element = document.getElementById('".$nodename."_vserver_version').innerHTML = '".$version[3]."';\n";
		$script .= "var element = document.getElementById('".$nodename."_utils_version').innerHTML = '".$version[4]."';\n";
		
		return $script;
	}
	
	function getTraffic($nodename, $year, $month) {
		ob_start();
		$traffic = NodeFactory::getNodeFactory()->getNodeByName($nodename)->getTraffic($month, $year);
		ob_end_clean();
		return number_format($traffic['total']/1000/1000/1000, 2)._("GB");
	}
	
	function getNode($nodename, $year, $month) {
		ob_start();
		$load = NodeFactory::getNodeFactory()->getNodeByName($nodename)->getLoad(true);
		$uptime = NodeFactory::getNodeFactory()->getNodeByName($nodename)->getUptime(true);
		$version = NodeFactory::getNodeFactory()->getNodeByName($nodename)->getVersion();
		$traffic = NodeFactory::getNodeFactory()->getNodeByName($nodename)->getTraffic($month, $year);
		$stat = NodeFactory::getNodeFactory()->getNodeByName($nodename)->getStat();

		$script = "var element = document.getElementById('".$nodename."_load').innerHTML = '".$load."';\n";
		$script .= "var element = document.getElementById('".$nodename."_uptime').innerHTML = '".$uptime."';\n";
		$script .= "var element = document.getElementById('".$nodename."_version').innerHTML = '".$version[0]." ".$version[1]."';\n";
		$script .= "var element = document.getElementById('".$nodename."_traffic_".$year."_".$month."').innerHTML = '".number_format($traffic['total']/1000/1000/1000, 2)._("GB")."';\n";
		$script .= "var element = document.getElementById('".$nodename."_stat').innerHTML = '".$stat['total']."/".$stat['online']."/".$stat['offline']."';\n";
		ob_end_clean();

		return $script;
	}
}


?>
