<?

class NodeViewHandler {
	
	function getVServerLoad($nodename, $vservername) {
		$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, NodeFactory::getNodeFactory()->getNodeByName($nodename)->getId());
		$load = $vserver->getLoad(true);
		return $load;
	}
	
	function getVServerUptime($nodename, $vservername) {
		$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, NodeFactory::getNodeFactory()->getNodeByName($nodename)->getId());
		$uptime = $vserver->getUptime(true);
		return $uptime;
	}
	
	function getVServerIPs($nodename, $vservername) {
		$XML =& OpenVCP::call('XML', 'getReference');
		$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, NodeFactory::getNodeFactory()->getNodeByName($nodename)->getId());
		$ips = "";
		$ipXML = $vserver->getIps();
		
		while(($ip = $XML->getNextStruct($ipXML)) != NULL)
		{
			$ips .= $ip['ip']."<br>";
		}
		if($ips == "")
		{
			$ips = "N/A";
		}

		return $ips;
	}
	
	function getVServerTraffic($nodename, $vservername, $year, $month) {
		ob_start();
		$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, NodeFactory::getNodeFactory()->getNodeByName($nodename)->getId());
		$traffic = $vserver->getTrafficTotal($month, $year);
		ob_end_clean();
		return number_format($traffic['total']/1000/1000/1000, 2);
	}
	
	function getVServer($nodename, $vservername) {
		ob_start();
		$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, NodeFactory::getNodeFactory()->getNodeByName($nodename)->getId());

		$load = $vserver->getLoad(true);
		$uptime = $vserver->getUptime(true);
		
		$script  = "var element = document.getElementById('".$vservername."_load').innerHTML = '".$load."';\n";
		$script .= "var element = document.getElementById('".$vservername."_uptime').innerHTML = '".$uptime."';\n";
		
		$ips = "";
		$ipXML = $vserver->getIps();
		$XML =& OpenVCP::call('XML', 'getReference');
		while(($ip = $XML->getNextStruct($ipXML)) != NULL)
		{
			$ips .= $ip['ip']."<br>";
		}
		if($ips == "")
		{
			$ips = "N/A";
		}
		$script .= "var element = document.getElementById('".$vservername."_ips').innerHTML = '".$ips."';\n";
		ob_end_clean();
		

		return $script;
	}
}

?>
