<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */
 
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

require_once('NodeFactory.class.php');

include "navi.php";


if($AUTH->getPrivileges('manage_admins') != 'y') 
{
	OpenVCP::gotoURL("super/admins");
}

if(isset($_POST['update']))
{
	//upgradind table_images
	$nodes = $DB->select($DB->table_nodes);
	foreach($nodes as $nodedata)
	{
		$node = NodeFactory::getNodeFactory()->getNodeByName($nodedata['name']);
		$images = $node->getImages();
		
		foreach($images as $name=>$id)
		{

			if(!is_array($DB->select($DB->table_images, NULL, NULL, array('name' => $id))))
			{
				$DB->insert($DB->table_images, array('', $nodedata['id'], $id, $name, ""));
			}
		}
	}
	$GUI->p(_("successfully updated"));
	$LOG->logInfo(_("updated images index"));
}
else if(@$PARAMS[0] == "edit") {
	if(@$PARAMS[2] == "save") {
		$DB->update($DB->table_images, array('alias' => $_POST['alias'], 'text' => nl2br(htmlspecialchars($_POST['description']))), array('name' => $_POST['name']));
		$GUI->p(_("image information saved"));
	}
	$image = $DB->select($DB->table_images, NULL, NULL, array('name' => $PARAMS[1]));
	$form = $GUI->form(0, "image_edit", (@$PARAMS[2] == "save" ? "save" : $PARAMS[1]."/save"));
	$table = $GUI->table($form);
	$GUI->formAddInputElement($form, "hidden", "name", $image[0]['name']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("name"));
	$GUI->tableAddCol($row, $image[0]['name']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("alias"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "input", "alias", $image[0]['alias']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("description"));
	$GUI->formAddTextarea($GUI->tableAddCol($row, ""), "description", strip_tags(htmlspecialchars_decode($image[0]['text'])));
	$GUI->formAddInputElement($form, "submit", "save", _("save settings"));
}
else
{
	if(@$PARAMS[0] == "save")
	{
		$DB->truncate($DB->table_admin_images);
		foreach($_POST['images'] as $admin => $image)
		{
			$admininfo = $DB->select($DB->table_admin, NULL, array("id", "loginname"), array('loginname' => $admin));
			foreach($image as $imagename)
			{
				$imageinfo = $DB->select($DB->table_images, NULL, NULL, array('name' => $imagename));
				$DB->insert($DB->table_admin_images, array('', 'adminid' => $admininfo[0]['id'], 'imageid' => $imageinfo[0]['id']));
			}
		}
		$GUI->p(_("successfully updated"));
		$LOG->logInfo(_("updated images for admins"));
	}

	$admins = $DB->select($DB->table_admin, NULL, array("id", "loginname"), NULL, array('loginname', 'ASC'));
	$GUI->p(_("this feature requires, that on all nodes exist the same images")."!");
	$form = $GUI->form(0, "images_admins", (@$PARAMS[0] == "save" ? "save" : "images/save"));
	$table = $GUI->table($form);
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	$GUI->tableAddCol($row, _("image name"));
	$i = 0;
	foreach($admins as $admin)
	{
		$GUI->tableAddCol($row, $admin['loginname']);
		$adminArray[$i]['id'] = $admin['id'];
		$adminArray[$i]['name'] = $admin['loginname'];
		$i++;
	}
	$images = $DB->select($DB->table_images);
	foreach($images as $image)
	{
			$row = $GUI->tableAddRow($table);
			$GUI->a($GUI->tableAddCol($row, ""), "super/admins/images/edit/".$image['name'], $image['name']);
			for($i = 0; $i < count($adminArray); $i++)
			{
				$admin = $DB->select($DB->table_admin_images, NULL, NULL, array('imageid' => $image['id'], 'AND', 'adminid' => $adminArray[$i]['id']));
				if(is_array($admin))
				{
					$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "images[".$adminArray[$i]['name']."][".$image['name']."]", $image['name'], true);
				}
				else
				{
					$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "images[".$adminArray[$i]['name']."][".$image['name']."]", $image['name'], false);
				}
			}
	}
	$GUI->formAddInputElement($form, "submit", "update", _("update imagelist"));
	$GUI->formAddInputElement($form, "submit", "save", _("save settings"));

	$GUI->p(_("all customers of a admin can only see the images which the admin can see"));
}

?>
