<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

require_once("CustomerFactory.class.php");
require_once("VserverFactory.class.php");
require_once("Sendmail.class.php");
			
if(@$PARAMS[0] == "vserver")
	OpenVCP::gotoURL("super/vservers/info/".$PARAMS[1]);

if(isset($PARAMS[0]) && is_string($PARAMS[0]))
	$customer = CustomerFactory::getInstance()->getUserByName($PARAMS[0]);
	
include "navi.php";

if(@$PARAMS[0] != "" && $PARAMS[0] != "disable" && $PARAMS[0] != "enable" && $PARAMS[0] != "su")
{
	$GUI->title(_("customer")." ".$PARAMS[0]);

	if($customer == null)
		OpenVCP::gotoURL("super/customers");	

	if($PARAMS[1] == "newlogin")
	{
		$password = createPassword(8);

		try
		{
			$mail = new Sendmail("add_customer", $USERINFO['id']);
			$content['firstname'] = $customer->getFirstname();
			$content['lastname'] = $customer->getLastname();
			$admin = AdminFactory::getInstance()->getUserByID($USERINFO['id']);
			$content['url'] = $admin->getSetting("url");
			$content['loginname'] = $customer->getLoginname();
			$content['password'] = $password;
			$mail->setTo($customer->getEmailaddress());
			$mail->replaceContent($content);
			$mail->sendMail();
			
			$DB->update($DB->table_user, array('password' => md5($password)), array('id' => $customer->getId()));
			$GUI->p(_("send mail to ")." ".$customer->getLoginname().' '._('sucessfully !'));
		}
		catch(Exception $e)
		{
			$GUI->p("Error: ".$e->getMessage());
			return;
		}
	}
	else
	if($PARAMS[1] == "email")
	{
		$ok = false;
		if($PARAMS[2] == "submit")
		{
			$ok = true;
			if($_POST['subject'] == "") $ok = false;
			if($_POST['mailbody'] == "") $ok = false;
		}
		if(!$ok)
		{
			$GUI->h(_("send mail to user")." ".$customer->getLoginname(), $GUI->tableAddCol($row, "", 2));
			$form = $GUI->form(0, "mailToUser", ($PARAMS[2] != "submit") ? "email/submit" : "submit");
			$table = $GUI->table($form);			 					
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, ($_POST['subject'] == "" && in_array("submit", $PARAMS)) ? $GUI->markUp(_("subject")." *", "red") : _("subject"));
			$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "subject", $_POST['subject']);
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, ($_POST['mailbody'] == "" && in_array("submit", $PARAMS)) ? $GUI->markUp(_("mailtext")." *", "red") : _("mailtext"));
			$GUI->formAddTextarea($GUI->tableAddCol($row, ""), "mailbody", $_POST['mailbody'], array('rows' => 15, 'cols' => 40));
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, _("include signature")."?");
			$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "signature", "include", ($_POST['signature'] != "include") ? false : true);
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, "");
			$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "submit", _("send_mail"), _("send_mail"));
			if(($_POST['subject'] == "" || $_POST['mailbody'] == "") && in_array("submit", $PARAMS)) $GUI->p("* "._("please enter text into the marked fields")."!");
		}
		else if($ok)
		{

			$GUI->p(_("sending mail to")." ".$customer->getLoginname());
			$mail = new Sendmail("", $USERINFO['id']);
			$mail->setTo($customer->getEmailaddress());
			$mail->setSubject($_POST['subject']);
			$mail->setContent($_POST['mailbody']);
			$mail->sendMail();
			$div = $GUI->div(_("ok"), "#green");
		}
		else
			OpenVCP::gotoURL("super/customers");
	}
	else
	{
		$table = $GUI->table();
		$thead = $GUI->tableAddHead($table);
		$row = $GUI->tableAddRow($thead);
		$GUI->h(_("customer")." ".$customer->getLoginname(),2, $GUI->tableAddCol($row, "", 2));
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("company"));
		$GUI->tableAddCol($row, $customer->getCompany());
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("firstname"));
		$GUI->tableAddCol($row, $customer->getFirstname());
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("lastname"));
		$GUI->tableAddCol($row, $customer->getLastname());
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("street"));
		$GUI->tableAddCol($row, $customer->getStreet());
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("postcode"));
		$GUI->tableAddCol($row, $customer->getPostcode());
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("city"));
		$GUI->tableAddCol($row, $customer->getCity());
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("phone"));
		$GUI->tableAddCol($row, $customer->getPhone());
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("fax"));
		$GUI->tableAddCol($row, $customer->getFax());
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("country"));
		$GUI->tableAddCol($row, $customer->getCountry());
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("emailaddress"));
		$GUI->tableAddCol($row, $customer->getEmailaddress());
		$row = $GUI->tableAddRow($table);
		
		$GUI->tableAddCol($row, _("vservers"));
		
		$vservers = VserverFactory::getInstance()->getVServersOfUser($customer->getId());
		
		$colum = $GUI->tableAddCol($row, "");
		foreach($vservers as $vs)
		{
			$row = $GUI->tableAddRow($table);
			$GUI->a($colum, "super/vservers/info/".$vs->getNode()."/".$vs->getName(), $vs->getName());
			
			$GUI->tableAddCol($row, "");
			$colum = $GUI->tableAddCol($row, "");
		}
		
		$GUI->br($colum);
		$row = $GUI->tableAddRow($table);
		//$colum = $GUI->tableAddCol($row, "");
		
		$colum = $GUI->tableAddCol($row, "");
		$form = $GUI->form($colum, "email", $PARAMS[0]."/email");

		$GUI->formAddInputElement($form, "submit", "email", _("mail to user"));
		
		$colum = $GUI->tableAddCol($row, "");
		$form = $GUI->form($colum, "email", $PARAMS[0]."/newlogin");
		$GUI->formAddInputElement($form, "submit", "email", _("send new login information"), array('onClick'=>"return confirm('"._('Do you really want to reset the password of this customer ?')."');"));

		


	}
}
else if(@$PARAMS[0] == "su")
{
	$AUTH->start_session($PARAMS[1], $USERINFO['password']);
}
else
{
	if(@$PARAMS[0] == "disable")
	{
		$DB->update($DB->table_user, array('active' => 'n'), array('loginname' => $PARAMS[1]));
		$LOG->logInfo(_("disabled useraccount")." ".$PARAMS[1]);
		$GUI->p(_("useraccount has been disabled"));
		
	}
	else if(@$PARAMS[0] == "enable")
	{
		$DB->update($DB->table_user, array('active' => 'y'), array('loginname' => $PARAMS[1]));
		$LOG->logInfo(_("enabled useraccount")." ".$PARAMS[1]);
		$GUI->p(_("useraccount has been enabled"));
	}	
	$GUI->title(_("customer overview"));
	$users = $DB->select($DB->table_user, NULL, NULL, ($AUTH->getPrivileges('see_all_users') == 'y') ? NULL : array('adminid' => $USERINFO['id']), array('loginname' => 'ASC'));
	$table = $GUI->table();
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, _("loginname"));
	$GUI->tableAddCol($row, _("firstname")."<br>"._("lastname"));
	$GUI->tableAddCol($row, _("vservers"));
	$GUI->tableAddCol($row, _("admin"));
	$GUI->tableAddCol($row, _("last login"));
	$GUI->tableAddCol($row, "");
	foreach($users as $user)
	{
		$row = $GUI->tableAddRow($table);		
		$col = $GUI->tableAddCol($row, "");
		if($user['active'] == 'y')
		{
			$GUI->img($GUI->a($col, "super/customers/disable/".$user['loginname'], ""), "green.png", true, _("disable"), 15, 15);
		}
		else
		{
			$GUI->img($GUI->a($col, "super/customers/enable/".$user['loginname'], ""), "red.png", true, _("enable"), 15, 15);
		}
		$GUI->a($GUI->tableAddCol($row, ""), "super/customers/su/".$user['loginname'] , $user['loginname'], "_blanc");
		$GUI->tableAddCol($row, $user['firstname']."<br>".$user['lastname']);
		$vservers = $DB->select($DB->table_vservers, NULL, NULL, array('userid' => $user['id']));
		$GUI->tableAddCol($row, (is_array($vservers) ? count($vservers) : 0));
		$admin = $DB->select($DB->table_admin, NULL, NULL, array('id' => $user['adminid']));
		$GUI->a($GUI->tableAddCol($row, ""), "super/admins/admin/".$admin[0]['loginname'] ,$admin[0]['loginname']);
		$GUI->tableAddCol($row, ($user['lastLogin'] ? strftime("%A, %D : %T", $user['lastLogin']) : _("never")));
		$col = $GUI->tableAddCol($row, "");
		$GUI->a($col, "super/customers/".$user['loginname'], _("show"));
		$GUI->br($col);
		$GUI->a($col, "super/customers/delete/".$user['loginname'], _("delete"));
		$GUI->br($col);
		$GUI->a($col, "super/customers/edit/".$user['loginname'], _("edit"));
	} 
}
?>
