<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

set_include_path(OPENVCP_ROOT_DIR."/core");
require_once('AdminFactory.class.php');
require_once("CustomerFactory.class.php");

if($AUTH->getPrivileges('see_logs') != 'y') OpenVCP::gotoURL("super/denied/see_logs");



if(!isset($_POST['type']) && isset($PARAMS[1])) $_POST['type'] = $PARAMS[1];


$form = $GUI->form(0, "select", "");
$table = $GUI->table($form);
$row = $GUI->tableAddRow($table);
$GUI->formAddCheckElement($GUI->tableAddCol($row, _("all")), "radio", "type", "", (@$_POST['type'] == "" ? true : false));
$GUI->formAddCheckElement($GUI->tableAddCol($row, _("info")), "radio", "type", "info", (@$_POST['type'] == "info" ? true : false));
$GUI->formAddCheckElement($GUI->tableAddCol($row, _("warn")), "radio", "type", "warn", (@$_POST['type'] == "warn" ? true : false));
$GUI->formAddCheckElement($GUI->tableAddCol($row, _("error")), "radio", "type", "error", (@$_POST['type'] == "error" ? true : false));
$GUI->formAddInputElement($GUI->tableAddCol($row), "submit", "submit", "submit");

$GUI->br();

$DB->select($DB->table_log, NULL, NULL, (@$_POST['type'] != "" ? array('type' => @$_POST['type']) :  NULL));
$countRows = $DB->select_numrows();
if($countRows < $PARAMS[0]) $PARAMS[0] = 0;

$logs = $DB->select($DB->table_log, array((isset($PARAMS[0]) && is_numeric($PARAMS[0]) ?  @$PARAMS[0] : 0), 39), NULL, (@$_POST['type'] != "" ? array('type' => @$_POST['type']) :  NULL), array('date' => 'DESC'));

$table = $GUI->table();
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("type"));
$GUI->tableAddCol($row, _("level"));
$GUI->tableAddCol($row, _("date"));
$GUI->tableAddCol($row, _("user"));
$GUI->tableAddCol($row, _("message"));
foreach($logs as $logentry)
{
	if($logentry['level'] == "admin")
		$user = AdminFactory::getInstance()->getUserByID($logentry['userid']);
	else if($logentry['level'] == "user")
		$user = CustomerFactory::getInstance()->getUserByID($logentry['userid']);
	else if($logentry['level'] == "auth_user")
		$user = CustomerFactory::getInstance()->getUserByID($logentry['userid']);
	else if($logentry['level'] == "auth_admin")
		$user = AdminFactory::getInstance()->getUserByID($logentry['userid']);
	else {
		$user = AdminFactory::getInstance()->getUserByID($logentry['userid']);
	}
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _($logentry['type']));
	$GUI->tableAddCol($row, _($logentry['level']));
	$GUI->tableAddCol($row, strftime("%A, %D : %T", $logentry['date']));
	$GUI->a($GUI->tableAddCol($row, ""), $user->createURL(), $user->getUsername());
	$GUI->tableAddCol($row, _($logentry['message']));
	$user = null;
}
$row = $GUI->tableAddRow($table);
$col = $GUI->tableAddCol($row, "Page: ", 5);
$j = 1;
for($i = 0; $i < $countRows; $i+=40) {
	$GUI->a($col, "super/log/".$i."/".$_POST['type'], " ".$j." ");
	$j++;
}
?>
