<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2008 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Gerrit Wyen / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB	=& OpenVCP::call('DB'  , 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

require_once('NodeFactory.class.php');
require_once('AdminFactory.class.php');
$node = NodeFactory::getNodeFactory()->getNodeByName(urldecode($PARAMS[0]));
include "navi.php";

$AUTH->getPrivileges('manage_nodes') == 'n' ? OpenVCP::gotoURL("super/nodes") : "";


$GUI->title(_("node details")." ".$node->getName());

$GUI->h($node->getName());

$table = $GUI->table();
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, "<b>"._("daemon:")."</b>");
$GUI->AddAjaxRequest($GUI->tableAddCol($row, "", "", "*", "", "", $node->getName()."_daemon_version"), 'NodeHandler', 'getVersion', array($node->getName()), true);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, "<b>"._("kernel:")."</b>");
$GUI->tableAddCol($row, "", "", "*", "", "", $node->getName()."_kernel_version");
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, "<b>"._("linux-vserver:")."</b>");
$GUI->tableAddCol($row, "", "", "*", "", "", $node->getName()."_vserver_version");
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, "<b>"._("util-vserver")."</b>");
$GUI->tableAddCol($row, "", "", "*", "", "", $node->getName()."_utils_version");


?>
