<?php
/**
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */

$AUTH   =& OpenVCP::call('Auth', 'getReference');
$GUI    =& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET	=& OpenVCP::call('Socket'  , 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information;

set_include_path(OPENVCP_ROOT_DIR."/core");

require_once('NodeFactory.class.php');
require_once('AdminFactory.class.php');

$ADMIN = AdminFactory::getInstance()->getUserByID($USERINFO['id']);

include "navi.php";


$jscallback = "var nodeHandlerCallback = {\n}";

$GUI->title(_("overview"));

$f = $GUI->fieldset(_("overview"));
$table = $GUI->table($f);
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, "");
$GUI->tableAddCol($row, _("node"));
if($AUTH->getPrivileges('manage_nodes') == 'y')
{
	$GUI->tableAddCol($row, _("IP Adress"));
	$GUI->tableAddCol($row, _("Traffic"));
	$GUI->tableAddCol($row, _("State"));
	$GUI->tableAddCol($row, _("load"));
	$GUI->tableAddCol($row, _("uptime"));
	$GUI->tableAddCol($row, _("vservers")."<br>"._("sum")."/"._("on")."/"._("off"));
	$GUI->tableAddCol($row, _("TLS"));
	$GUI->tableAddCol($row, _("Version"));
	$GUI->tableAddCol($row, "");
}

$currentMonth = date("m");
$year = date("Y");

$i=1;
foreach($ADMIN->getNodes() as $nodeInfo)
{
	$node = NodeFactory::getNodeFactory()->getNodeByName($nodeInfo['name']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, $i.".");
	$GUI->a($GUI->tableAddCol($row, ""), "super/nodes/node/".$node->getName(), $node->getName());
	if($AUTH->getPrivileges('manage_nodes') == 'y')
	{
		$GUI->tableAddCol($row, $node->getIP());
		if($SOCKET->socket_connect($node->getId()))
		{
			$GUI->AddAjaxRequest($GUI->tableAddCol($row, "", 1, "*", 0, "left", $node->getName()."_traffic_".$year."_".$currentMonth), 'NodeHandler', 'getNode', array($node->getName(), $year, $currentMonth), true);
			$GUI->img($GUI->tableAddCol($row, ""), "green.png", true, _("online"), 15, 15);
			$GUI->tableAddCol($row, "", 1, "*", 0, "left", $node->getName()."_load");
			$GUI->tableAddCol($row, "", 1, "*", 0, "left", $node->getName()."_uptime");
		}
		else
		{
			$GUI->tableAddCol($row, "n/a");
			$GUI->img($GUI->tableAddCol($row, ""), "red.png", true, _("offline"), 15, 15);
			$GUI->tableAddCol($row, "n/a");
			$GUI->tableAddCol($row, "n/a");
		}
		$GUI->tableAddCol($row, "", 1, "*", 0, "center", $node->getName()."_stat");
		$GUI->tableAddCol($row, $node->getTLS() == "y" ? "Yes" : "No");
		$GUI->tableAddCol($row, "", 1, "*", 0, "left", $node->getName()."_version");
		$col = $GUI->tableAddCol($row, "");
		$GUI->a($col, "super/nodes/details/".$node->getName(), _("details"));
		$GUI->br($col);
		$GUI->a($col, "super/nodes/edit/".$node->getName(), _("edit"));
		$GUI->br($col);
		$GUI->a($col, "super/nodes/delete/".$node->getName(), _("delete"));
	}

	$i++;
}
?>
