<?php
/**
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */


OpenVCP::setTextdomain('super_nodes_navi');

$GUI->addContentMenuHead(_("Nodes"));
$GUI->addContentMenuSub("overview", _("overview"));

if($AUTH->getPrivileges('manage_nodes') == 'y')
{
	$GUI->addContentMenuSub("add", _("add node"));
}
$GUI->addContentMenuSpace();

$nodes = $DB->select($DB->table_nodes);
$GUI->addContentMenuHead(_("Node"), 3, 1);

$ADMIN = AdminFactory::getInstance()->getUserByID($USERINFO['id']);

foreach($ADMIN->getNodes() as $nodearg)
{
	$GUI->addContentMenuSub("node/".urlencode($nodearg['name']),$nodearg['name'], 2);
	
	if(isset($node) && is_object($node) && $node->getName() == $nodearg['name'])
	{
		if($AUTH->getPrivileges('manage_nodes') == 'y')
		{

			$GUI->addContentMenuHead(_("Node options"), 4, 2);
			$GUI->addContentMenuSub("node/".urlencode($node->getName())."/network", _("manage ip's"), 3);
			$GUI->addContentMenuSub("node/".urlencode($node->getName())."/network/add", _("add ip's'"), 3);	
			$GUI->addContentMenuSub("control/".urlencode($node->getName()), _("control node"), 3);	
			$GUI->addContentMenuSub("edit/".urlencode($node->getName()), _("edit node"), 3);			
		}
	}
}



if($AUTH->getPrivileges('manage_nodes') == 'y')
{
	$GUI->addContentMenuSpace();
	$GUI->addContentMenuHead(_("Misc"));
	$GUI->addContentMenuSub("update", _("update vserver list"), 1);
}

OpenVCP::resetTextdomain();
?>
