<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */

$PARAMS =& OpenVCP::getParams();
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$USERINFO = $AUTH->user_information;
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');

require_once "Sendmail.class.php";
require_once "Vserver.class.php";
require_once "NodeFactory.class.php";
require_once "VserverFactory.class.php";
require_once("CustomerFactory.class.php");
require_once('AdminFactory.class.php');

if(isset($_POST['submit']) && strlen($_POST['term']) > 0) {
	if($AUTH->getPrivileges('see_admins') == 'y')
	{
		$admins = $DB->select($DB->table_admin, NULL, NULL, array('loginname' => "%".$_POST['term']."%", 'OR', 'firstname' => "%".$_POST['term']."%", 'OR', 'lastname' => "%".$_POST['term']."%", 'OR', 'company' => "%".$_POST['term']."%"));
		$GUI->br();
		$GUI->h(_("search results for admins"), 2);
		$GUI->br();
		$table = $GUI->table();
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("loginname"));
		$GUI->tableAddCol($row, _("company"));
		$GUI->tableAddCol($row, _("firstname"));
		$GUI->tableAddCol($row, _("lastname"));
			
		if(is_array($admins)) {
			foreach($admins as $admin) {
				$row = $GUI->tableAddRow($table);
				$GUI->a($GUI->tableAddCol($row, ""), "super/admins/admin/".$admin['loginname'], $admin['loginname']);
				$GUI->tableAddCol($row, $admin['company']);
				$GUI->tableAddCol($row, $admin['firstname']);
				$GUI->tableAddCol($row, $admin['lastname']);
			}
		}
		else
			$GUI->p(_("no admins found"));
	}
	if($AUTH->getPrivileges('see_all_users') == 'y')
		$users = $DB->select($DB->table_user, NULL, NULL, array('loginname' => "%".$_POST['term']."%", 'OR', 'firstname' => "%".$_POST['term']."%", 'OR', 'lastname' => "%".$_POST['term']."%", 'OR', 'company' => "%".$_POST['term']."%"));
	else
		$users = $DB->select($DB->table_user, NULL, NULL, array(array('loginname' => "%".$_POST['term']."%", 'OR', 'firstname' => "%".$_POST['term']."%", 'OR', 'lastname' => "%".$_POST['term']."%", 'OR', 'company' => "%".$_POST['term']."%"), 'AND', 'adminid' => $USERINFO['id']));
	$GUI->br();
	$GUI->h(_("search results for customers"), 2);
	$GUI->br();
	$table = $GUI->table();
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("loginname"));
	$GUI->tableAddCol($row, _("company"));
	$GUI->tableAddCol($row, _("firstname"));
	$GUI->tableAddCol($row, _("lastname"));
	$GUI->tableAddCol($row, _("admin"));
	if(is_array($users)) {
		foreach($users as $user) {
			$customer = CustomerFactory::getInstance()->getUserByName($user['loginname']);
			$row = $GUI->tableAddRow($table);
			$GUI->a($GUI->tableAddCol($row, ""), "super/customers/".$customer->getLoginname(), $customer->getLoginname());
			$GUI->tableAddCol($row, $customer->getCompany());
			$GUI->tableAddCol($row, $customer->getFirstname());
			$GUI->tableAddCol($row, $customer->getLastname());
			$GUI->tableAddCol($row, $customer->getAdminObject()->getLoginname());
		}
	}
	else
		$GUI->p(_("no customers found"));
	
	$admin = AdminFactory::getInstance()->getUserByID($USERINFO['id']);
	$nodes = $admin->getNodes();
	
	$GUI->br();
	$GUI->h(_("search results for nodes"), 2);
	$GUI->br();
	if(is_array($nodes)) {
		$found = false;
		$table = $GUI->table();
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("name"));
		$GUI->tableAddCol($row, _("ip"));
		$GUI->tableAddCol($row, _("state"));
		$GUI->tableAddCol($row, _("vserver count"));
		foreach($nodes as $node) {
			if(strstr($node['name'], $_POST['term']) || strstr($node['ip'], $_POST['term'])) {
				$nodeObject = NodeFactory::getNodeFactory()->getNodeByName($node['name']);
				$row = $GUI->tableAddRow($table);
				$GUI->a($GUI->tableAddCol($row, ""), "super/nodes/node/".$nodeObject->getName(), $nodeObject->getName());
				$GUI->tableAddCol($row, $nodeObject->getIP());
				$GUI->img($GUI->tableAddCol($row, ""), ($nodeObject->getSpace() != null) ? "green.png" : "red.png", true, ($nodeObject->getSpace() != null) ? _("online") : _("offline"), 15, 15);
				$GUI->tableAddCol($row, $nodeObject->getVServerCount());
				$found = true;
			}
		}
	}
	if(!$found)
		$GUI->p(_("no nodes found"));
	
	if($AUTH->getPrivileges('see_all_vserver') == 'y')
		$vservers = $DB->select($DB->table_vservers, NULL, NULL, array('name' => "%".$_POST['term']."%"));
	else
		$vservers = $DB->select($DB->table_vservers, NULL, NULL, array('name' => "%".$_POST['term']."%", 'AND', 'adminid' => $USERINFO['id']));
	
	$GUI->br();
	$GUI->h(_("search results for vservers"), 2);
	$GUI->br();
	$table = $GUI->table();
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("name"));
	$GUI->tableAddCol($row, _("node"));
	$GUI->tableAddCol($row, _("customer"));
	$GUI->tableAddCol($row, _("state"));
	if(is_array($vservers)) {
		foreach($vservers as $vserver) {
			$vs = VserverFactory::getInstance()->getVServerByNameAndNode($vserver['name'], $vserver['nodeid']);
			$row = $GUI->tableAddRow($table);
			$GUI->a($GUI->tableAddCol($row, ""), "super/vservers/info/".$vs->getNodeObject()->getName()."/".$vs->getName(), $vs->getName());
			$GUI->a($GUI->tableAddCol($row, ""), "super/nodes/node/".$vs->getNodeObject()->getName(), $vs->getNodeObject()->getName());
			$GUI->a($GUI->tableAddCol($row, ""), "super/customers/".$vs->getUserObject()->getLoginname(), $vs->getUserObject()->getLoginname());
			$GUI->img($GUI->tableAddCol($row, ""), ($vs->getState() == "Online") ? "green.png" : "red.png", true, ($vs->getState() == "Online") ? _("online") : _("offline"), 15, 15);
		}
	}
	else
		$GUI->p(_("no vservers found"));

	$vservers = $DB->select($DB->table_network, NULL, NULL, array('ip' => "%".$_POST['term']."%"));

	$GUI->br();
	$GUI->h(_("search results for vserver ip"), 2);
	$GUI->br();
	$table = $GUI->table();
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("name"));
	$GUI->tableAddCol($row, _("node"));
	$GUI->tableAddCol($row, _("customer"));
	$GUI->tableAddCol($row, _("state"));

	if(is_array($vservers)) {
		foreach($vservers as $vserver) {
			$vs = VserverFactory::getInstance()->getVserverByID($vserver['vserverid']);
			$row = $GUI->tableAddRow($table);
			$GUI->a($GUI->tableAddCol($row, ""), "super/vservers/info/".$vs->getNodeObject()->getName()."/".$vs->getName(), $vs->getName());
			$GUI->a($GUI->tableAddCol($row, ""), "super/nodes/node/".$vs->getNodeObject()->getName(), $vs->getNodeObject()->getName());
			$GUI->a($GUI->tableAddCol($row, ""), "super/customers/".$vs->getUserObject()->getLoginname(), $vs->getUserObject()->getLoginname());
			$GUI->img($GUI->tableAddCol($row, ""), ($vs->getState() == "Online") ? "green.png" : "red.png", true, ($vs->getState() == "Online") ? _("online") : _("offline"), 15, 15);
		}
	}
	else
		$GUI->p(_("no vservers found"));
}
?>
