<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$XML    =& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information;

require_once('AdminFactory.class.php');
require_once('VserverFactory.class.php');
require_once('NodeFactory.class.php');
require_once("Customer.class.php");
$ADMIN = AdminFactory::getInstance()->getUserByID($USERINFO['id']);

$nodename = $PARAMS[0];
$vservername = $PARAMS[1];
$node = NodeFactory::getNodeFactory()->getNodeByName($nodename);


$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, $node->getId());

$task = "bandwidth";

require_once "navi.php";

$f = $GUI->fieldset(_("bandwidth"));

if(@$PARAMS[2] == "add") {
	$form = $GUI->form($f, "limits", "submit");
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("Direction"));
	$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "direction", array('IN' => 'IN', 'OUT' => 'OUT'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("Rate")." [KByte/s]");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "rate");
	$GUI->formAddInputElement($form, "submit", "submit", _("add"));
}
else {
	if(@$PARAMS[2] == "submit") {
		$vserver->setBandwidth($_POST['direction'], $_POST['rate'], $_POST['rate']);
	}
	if(@$PARAMS[2] == "delete") {
		foreach($_POST['bandwidth'] as $todelete) {
			$vserver->delBandwidth($todelete);
		}
		$GUI->p(_("please note: bandwidth limits are deleted on the node once a hour"));
	}
	$bandwidth = $vserver->getBandwidth();
	
	$form = $GUI->form($f, "iptables_list", (@$PARAMS[2] != "delete" ? $PARAMS[1] . "/delete" : "delete"));
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("direction"));
	$GUI->tableAddCol($row, _("rate"));
	$GUI->tableAddCol($row, "&nbsp;");
	while(($rule = $XML->getNextStruct($bandwidth)) != null)
	{
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, $rule['direction']);
		$GUI->tableAddCol($row, $rule['rate']);
		$GUI->formAddCheckelement($GUI->tableAddCol($row, ""), "checkbox", "bandwidth[" . $rule['direction'] . "]", $rule['direction'] );
	}
	$GUI->formAddInputElement($form, "submit", "submit", _("delete"));
}
?>
