<?php
/**
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */
$AUTH   =& OpenVCP::call('Auth', 'getReference');
$GUI    =& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information;

require_once('VserverFactory.class.php');
require_once('NodeFactory.class.php');

$nodename = $PARAMS[0];
$vservername = $PARAMS[1];
$node = NodeFactory::getNodeFactory()->getNodeByName($nodename);

$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, $node->getId());

include "navi.php";

$state = $vserver->getState();

if(isset($_POST['stop']))
{
	$GUI->title(_("Stop vserver"));
	if($state == "Online")
	{
		$GUI->div(_("stopping")." ".$vserver->getName()." ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$dmesg = $vserver->controlStop();
		$state = $vserver->getState();
		$state == "Offline" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
		$f = $GUI->fieldset(_("output"), "dmesg");
		foreach($dmesg as $msg)
			foreach(explode('<br />', $msg) as $line) {
				$GUI->addToElementID($f, $line."<br />");
			}
		$GUI->br();
		$GUI->flushContent();
	}
	else
	{
		$GUI->div($vserver->getName(), "left");
		$GUI->div(_("already stopped"), "rightred");
		$GUI->br();
		$GUI->flushContent();
	}
}
else if(isset($_POST['start']))
{
	$GUI->title(_("Start vserver"));
	if($state == "Offline")
	{
		$GUI->div(_("starting")." ".$vserver->getName()." ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$dmesg = $vserver->controlStart();
		$state = $vserver->getState();
		$state == "Online" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
		$f = $GUI->fieldset(_("output"), "dmesg");
		foreach($dmesg as $msg)
			foreach(explode('<br />', $msg) as $line) {
				$GUI->addToElementID($f, $line."<br />");
			}
		$GUI->br();
		$GUI->flushContent();
	}
	else
	{
		$GUI->div($vserver->getName(), "left");
		$GUI->div(_("already started"), "rightred");
		$GUI->br();
		$GUI->flushContent();
	}
}
else if(isset($_POST['restart']))
{
	$GUI->title(_("Restart vserver"));
	if($state == "Online")
	{
		$GUI->div(_("stopping")." ".$vserver->getName()." ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$dmesg = $vserver->controlStop();
		$GUI->div(_("ok"), "rightgreen");
		$f = $GUI->fieldset(_("output"), "dmesg");
		foreach($dmesg as $msg)
			foreach(explode('<br />', $msg) as $line) {
				$GUI->addToElementID($f, $line."<br />");
			}
		$GUI->br();
		$GUI->flushContent();
		$GUI->div(_("starting")." ".$vserver->getName()." ....", "left");
		$GUI->flushContent();
		sleep(1);
		$GUI->flushContent();
		$dmesg = $vserver->controlStart();
		$state = $vserver->getState();
		$state == "Online" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
		$f = $GUI->fieldset(_("output"), "dmesg");
		foreach($dmesg as $msg)
			foreach(explode('<br />', $msg) as $line) {
				$GUI->addToElementID($f, $line."<br />");
			}
		$GUI->br();
		$GUI->flushContent();
	}
	else
	{
		$GUI->div($vserver->getName(), "left");
		$GUI->div(_("not started"), "rightred");
		$GUI->br();
		$GUI->flushContent();
	}
}
else
{
	$GUI->title(_("Options of vserver")." ".$vserver->getName());
	$f = $GUI->fieldset("control vServer");
	$form = $GUI->form($f, "vs_control", $vserver->getName());

	if($state == "Online")
	{
		$GUI->p(_("vserver is online")."!", $form);
		$GUI->formAddInputElement($form, "submit", "stop", _("stop"));
		$GUI->formAddInputElement($form, "submit", "restart", _("restart"));
	}
	else
	{
		$GUI->p(_("vserver is offline")."!", $form);
		$GUI->formAddInputElement($form, "submit", "start", _("start"));
	}
}
?>
