<?php
/**
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */
$AUTH   =& OpenVCP::call('Auth', 'getReference');
$GUI    =& OpenVCP::call('GUI' , 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information;

require_once('VserverFactory.class.php');
require_once('NodeFactory.class.php');

$nodename = $PARAMS[0];
$vservername = $PARAMS[1];
$node = NodeFactory::getNodeFactory()->getNodeByName($nodename);


$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, $node->getId());

require_once("navi.php");

$GUI->title(_("Options of vserver")." ".$vserver->getName());

if(isset($_POST['submitflags']))
{
	$vserver->setAutostart($_POST['autostart']);
	foreach( array( 'sched_hard', 'virt_mem', 'virt_uptime', 'virt_cpu', 'virt_load' ) as $flag )
	{
		if ( $_POST[$flag] == "1")
		{
			$vserver->addFlag($flag);
		}
		else if ( $_POST[$flag] == "0")
		{
			$vserver->removeFlag($flag);
		}
	}
	$GUI->p(_("Flags succesfully set. Make sure to restart the vserver before the changes take affect."));
}

$f = $GUI->fieldset(_("flags"));
$GUI->h(_("edit flags"), 2, $f);
$form = $GUI->form($f, "flags", (@$PARAMS[2] == "submit" ? "submit" : $PARAMS[1]."/submit"));
$table = $GUI->table($form);

$autostart = $vserver->getAutostart();

$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("autostart"));
$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "autostart", array(_("no") => '0', _("yes") => '1'), $autostart);
$flags = $vserver->getFlags();
$flags = implode(" ",$flags);
foreach( array( 'sched_hard', 'virt_mem', 'virt_uptime', 'virt_cpu', 'virt_load' ) as $flag )
{
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _($flag));
	$GUI->formAddDropdown($GUI->tableAddCol($row, ""), $flag, array(_("no") => '0', _("yes") => '1'), (( strpos($flags, $flag) === false ) ? "0" : "1"));
}
$GUI->formAddInputElement($form, "submit", "submitflags", _("save"));
?>
