<?php
/**
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */
$AUTH   =& OpenVCP::call('Auth', 'getReference');
$GUI    =& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information;

require_once('VserverFactory.class.php');
require_once('NodeFactory.class.php');

$nodename = $PARAMS[0];
$vservername = $PARAMS[1];

$node = NodeFactory::getNodeFactory()->getNodeByName($nodename);

$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, $node->getId());

require_once("navi.php");

if(@$PARAMS[2] == "submit" && isset($_POST['hostname']))
{
	if($_POST['admin'] == "none") $_POST['admin'] = -1;
	if($_POST['customer'] == "none") $_POST['customer'] = -1;
	if($_POST['enabled'] == "YES")
		$vserver->enableVserver();
	else
		$vserver->disableVServer();

	$vserver->setHostname($_POST['hostname']);
	$vserver->updateInfo($_POST['customer'], $_POST['admin']);
	$GUI->p(_("update successfully")."!");
}

$form = $GUI->form(0, "vserver_info", (@$PARAMS[2] == "submit" ? "submit" : $PARAMS[1]."/submit"));
$table = $GUI->table($form);
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("vservername"));
$GUI->tableAddCol($row, $vserver->getName());
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("customername"));
$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "customer", createDropdownContent("table_user", array('id', 'loginname'), ($AUTH->getPrivileges('see_all_users') == 'y') ? NULL : array('adminid' => $USERINFO['id']), "none", array('loginname' => 'ASC')), $vserver->getUserObject()->getId());
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("node"));
$GUI->tableAddCol($row, $node->getName());
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("adminname"));
$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "admin", createDropdownContent("table_admin", array('id', 'loginname'), ($AUTH->getPrivileges('see_admins') == 'y') ? NULL : array('id' => $USERINFO['id']), "none", array('loginname' => 'ASC')), $vserver->getAdminObject()->getId());
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("hostname"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "hostname", $vserver->getHostname());

$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("enabled"));
$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "enabled", array(_("yes") => 'YES', _("no") => 'NO'), ($vserver->isDisabled() == false ? 'YES' : 'NO'));

$row = $GUI->tableAddRow($table);
$state = $vserver->getState();
$GUI->tableAddCol($row, _("state"));

$col = $GUI->tableAddCol($row, $state." ");
if($state == "Online")
$GUI->img($col, "green.png", true, _("online"), 15, 15);
else
$GUI->img($col, "red.png", true, _("offline"), 15, 15);

$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("load"));
$GUI->tableAddCol($row, $vserver->getLoad(true));


$GUI->formAddInputElement($form, "submit", _("submit"), _("submit"));
?>
