<?php
/**
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */
$AUTH   =& OpenVCP::call('Auth', 'getReference');
$GUI    =& OpenVCP::call('GUI' , 'getReference');
$DB    =& OpenVCP::call('DB' , 'getReference');
$XML    =& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information;

require_once('VserverFactory.class.php');
require_once('NodeFactory.class.php');

$nodename = $PARAMS[0];
$vservername = $PARAMS[1];
$node = NodeFactory::getNodeFactory()->getNodeByName($nodename);


$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, $node->getId());


require_once("navi.php");

$GUI->title(_("Options of vserver")." ".$vserver->getName());
if(isset($_POST['addip']))
{
	$nodev="";
	
	if($_POST['ipsingle'] == "")
	{
		$ipinfo = $DB->select($DB->table_network, NULL, NULL, array('id' => $_POST['ip']));
		print_r($ipinfo);
		$ip = $ipinfo[0]['ip'];
		$dev = $_POST['interface'];	
		$mask = $ipinfo[0]['netmask'];
		$bcast = $ipinfo[0]['broadcast'];
	}
	else
	{
		$DB->insert($DB->table_network, array('id' => '', 'ip' => $_POST['ipsingle'], 'vserverid' => $vserver->getID(), 'nodeid' => $node->getId(), 'used' => 'y', 'netmask' => $_POST['netmask'], 'broadcast' => $_POST['broadcast'], 'reservation' => ''));
		$ip = $_POST['ipsingle'];
		$dev = $_POST['interfacesingle'];	
		$mask = $_POST['netmask'];
		$bcast = $_POST['broadcast'];
	}
	
	if(@$_POST['alias'] != "")
	{
		$alias =  $_POST['alias'];
	}
	else
	{
		$response = $vserver->getIps();
		$i = 0;
		while(($ifaceCounter = $XML->getNextStruct($response)) != null)
		{
			$i++;
		}
		$alias = $vserver->getName().$i;
	}
	if($dev == "nodev")
		$nodev="true";
	else if($dev == "tun" || $dev == "tap")
	{
		$tuntap = $dev;
		$dev = $dev.$alias;
		$alias = "";
	}	
	
	$DB->update($DB->table_network, array('used' => 'y', 'vserverid' => $vserver->getID()) ,array('ip' => $ip));
	$vserver->addIp($ip, $dev, $mask, $alias, $bcast, $nodev, $tuntap);
	$GUI->p(_("ip successfully added. Make sure to restart the vserver before the changes take affect."));
}
else if(isset($_POST['deleteip']))
{
	if(isset($_POST['ips']) && is_array($_POST['ips']))
	{
		foreach($_POST['ips'] as $id => $ip)
		{
			$vserver->removeIp($id, $ip);
		}
	}
	$GUI->p(_("ip successfully deleted. Make sure to restart the vserver before the changes take affect."));
}

$f = $GUI->fieldset(_("manage ip's"));
$GUI->h(_("ip overview"), 2, $f);
$form = $GUI->form($f, "vserver_options", $vserver->getName());
$table = $GUI->table($form);
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("device"));
$GUI->tableAddCol($row, _("alias"));
$GUI->tableAddCol($row, _("ip"));
$GUI->tableAddCol($row, _("netmask"));
$GUI->tableAddCol($row, _("broadcast"));
$GUI->tableAddCol($row, "");

$response = $vserver->getIps();

while(($ip = $XML->getNextStruct($response)) != null)
{
	if($ip['nodev'] != "")
		$ip['dev'] = "nodev";
		 
	if($ip['name'] == 'noname')
	$ip['name'] = "";
	if($ip['mask'] == 'nomask')
	$ip['mask'] = "";
	if($ip['bcast'] == 'nobcast')
	$ip['bcast'] = "";

	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, $ip['dev']);
	$GUI->tableAddCol($row, $ip['name']);
	$GUI->tableAddCol($row, $ip['ip']);
	$GUI->tableAddCol($row, $ip['mask']);
	$GUI->tableAddCol($row, $ip['bcast']);
	$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "ips[".$ip['id']."]", $ip['ip']);
}
$GUI->formAddInputElement($form, "submit", "deleteip", _("delete ip"));

///Add IP
$GUI->br($f);
$GUI->h(_("add ip"), 2, $f);
$form = $GUI->form($f, "add_ip", $vserver->getName());
$table = $GUI->table($form);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("ip address").": ");
$col = $GUI->tableAddCol($row, "");
$GUI->formAddDropdown($col, "ip", $vserver->getNodeObject()->getAvailableIps());

$ifaceList = $vserver->getNodeObject()->getInterfaces();
array_push($ifaceList, "nodev");
sort($ifaceList);

foreach($ifaceList as $interface)
{
	$ifaceDrop[$interface] = $interface;

}
$GUI->formAddDropdown($col, "interface", $ifaceDrop);
$row = $GUI->tableAddRow($table);
$col = $GUI->br($GUI->tableAddCol($row,""));
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("custom ip").": ");
$col = $GUI->tableAddCol($row, "");
$GUI->formAddInputElement($col, "text", "ipsingle");
$ifaceDrop['create tun'] = "tun";
$ifaceDrop['create tap'] = "tap";
$GUI->formAddDropdown($col, "interfacesingle", $ifaceDrop);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("netmask").": ");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "netmask");
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("broadcast").": ");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "broadcast");
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("custom alias").": ");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "alias");
$GUI->formAddInputElement($form, "submit", "addip", _("add ip"));
?>
