<?php
/**
* OpenVCP Webinterface
* Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*
* @author  Oliver Werner / OpenVCP Team
* @version 0.4.0.1
* @package OpenVCP-v0.4
*/

$AUTH   =& OpenVCP::call('Auth', 'getReference');
$GUI    =& OpenVCP::call('GUI' , 'getReference');
$PARAMS =& OpenVCP::getParams();

$USERINFO = $AUTH->user_information;

require_once('AdminFactory.class.php');
require_once("VserverFactory.class.php");
require_once('NodeFactory.class.php');

$ADMIN = AdminFactory::getInstance()->getUserByID($USERINFO['id']);

if(@$PARAMS[0] == "gotou")
	OpenVCP::gotoURL("super/customers/".$PARAMS[1]);
if(@$PARAMS[0] == "goton")
	OpenVCP::gotoURL("super/nodes/node/".$PARAMS[1]);

include "navi.php";

if(@$PARAMS[0] == "changestate") {
	$node = NodeFactory::getNodeFactory()->getNodeByName($PARAMS[1]);
	$vservername = $PARAMS[2];
	$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, $node->getId());
	if($vserver->isDisabled()) {
		$vserver->enableVserver();
		$GUI->p(_("enabled vserver")." ".$vserver->getName());
	}
	else {
		$vserver->disableVServer();
		$GUI->p(_("disabled vserver")." ".$vserver->getName());
	}
}
else if(@$PARAMS[0] != "")
{
	OpenVCP::gotoURL("super/customers/vservers/".$PARAMS[0]."/info");
}

$GUI->title(_("vserver overview"));
$table = $GUI->table();
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("active"));
$GUI->tableAddCol($row, _("name"));
$GUI->tableAddCol($row, _("admin"));
$GUI->tableAddCol($row, _("customer"));
$GUI->tableAddCol($row, _("node"));
$vservers = VserverFactory::getInstance()->getVserversOfAdmin($ADMIN);

if(is_array($vservers))
{
	foreach($vservers as $vserver)
	{
		$row = $GUI->tableAddRow($table);
		$GUI->img($GUI->a($GUI->tableAddCol($row, ""), "super/vservers/changestate/".$vserver->getNodeObject()->getName()."/".$vserver->getName(), ""), ($vserver->isDisabled()) ? "red.png" : "green.png", true, ($vserver->isDisabled() ? _("disabled") : _("enabled")), 15, 15);
		$GUI->a($GUI->tableAddCol($row, ""), "super/vservers/info/".$vserver->getNodeObject()->getName()."/".$vserver->getName(), $vserver->getName());
		$GUI->tableAddCol($row, $vserver->getAdmin() != -1 ? $vserver->getAdminObject()->getUsername() : _("not set"));
		$GUI->tableAddCol($row, $vserver->getUser() != -1 ? $vserver->getUserObject()->getUsername() : _("not set"));
		$GUI->a($GUI->tableAddCol($row, ""), "super/nodes/node/".$vserver->getNodeObject()->getName() ,$vserver->getNodeObject()->getName());
	}
}

?>
