<?php
/**
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */

$AUTH   =& OpenVCP::call('Auth', 'getReference');
$GUI    =& OpenVCP::call('GUI' , 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information;

require_once('VserverFactory.class.php');
require_once('NodeFactory.class.php');
require_once('AdminFactory.class.php');

$nodename = $PARAMS[0];
$vservername = $PARAMS[1];
$node = NodeFactory::getNodeFactory()->getNodeByName($nodename);

$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, $node->getId());

$ADMIN = AdminFactory::getInstance()->getUserByID($USERINFO['id']);

require_once("navi.php");

$osDD = array();
if(($oslist = $ADMIN->getImages()) == null)
{
	$osDD = $vserver->getNodeObject()->getImages();
}
else
{
	foreach($oslist as $key=>$os) {

		if(is_numeric($key))
		$osDD[$os] = $os;
		else
		$osDD[$key] = $os;
	}
}

if(isset($_POST['submit']) && in_array($_POST['image'], $osDD))
{
	$GUI->flushContent();

	$state = $vserver->getState();
	$offline = false;
	if($state == "Online")
	{
		$GUI->flushContent();
		$GUI->div(_("stopping vserver")." ".$vserver->getName()."...", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$dmesg = $vserver->controlStop();
		$state = $vserver->getState();
		if($state == "Offline")
		{
			$GUI->div(_("ok"), "rightgreen");
			$GUI->flushContent();
		}
		else
		{
			$GUI->div(_("failed"), "rightred");
			$GUI->p(_("error stopping vserver")." ".$vserver->getName()."!");
			$GUI->p(_("please contact support")."!");
			$GUI->flushContent();
			exit();
		}
		$f = $GUI->fieldset(_("output"), "dmesg");
		foreach($dmesg as $msg)
			foreach(explode('<br />', $msg) as $line) {
				$GUI->addToElementID($f, $line."<br />");
			}
		$GUI->flushContent();
	}
	
	$GUI->div(_("reinstall vserver")." ".$vserver->getName()." with image ".$_POST['image']." ...", "left");
	$GUI->flushContent();
	$GUI->flushContent();
	$install = $vserver->controlSetupImage($_POST['image']);
	if($install == 1)
	{
		$GUI->div(_("ok"), "rightgreen");
		$GUI->div(_("starting vserver")." ".$vserver->getName()."...", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$dmesg = $vserver->controlStart();
		$GUI->flushContent();
		$GUI->flushContent();
		$state = $vserver->getState();
		if($state == "Online")
		{
			$GUI->div(_("ok"), "rightgreen");
			$GUI->flushContent();
			$password = createPassword(8);
			$GUI->div(_("setting rootpassword")." ".$vserver->getName()."...", "left");
			$GUI->flushContent();

			$vserver->controlSetupPassword($password);

			$GUI->div(_("ok"), "rightgreen");
			$GUI->p(_("vserver")." ".$vserver->getName()." "._("sucessfully reinstalled"));
			$GUI->p(_("new root password is").": ".$password);
		}
		else
		{
			$GUI->div(_("failed"), "rightred");
			$GUI->p(_("error starting vserver")." ".$vserver->getName()."!");
			$GUI->p(_("please contact support")."!");
			$GUI->flushContent();
		}
		$f = $GUI->fieldset(_("output"), "dmesg");
		foreach($dmesg as $msg)
			foreach(explode('<br />', $msg) as $line) {
				$GUI->addToElementID($f, $line."<br />");
			}
	}
	else
	{
		$GUI->div(_("failed"), "rightred");
		$GUI->p(_("error reinstalling vserver")." ".$vserver->getName()."!");
		$GUI->p(_("please contact support")."!");
		$GUI->flushContent();
	}
}
else if($vserver && !isset($_POST['submit']))
{
	$form = $GUI->form(0, "vserver_reinstall", $vserver->getName());
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("available images"),3);
	if($oslist != null) {
		$images = $ADMIN->getImagesExtended();
		foreach($images as $os) {
			$row = $GUI->tableAddRow($table);
			$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "radio", "image", $os['name']);
			if($os['alias'] != '')
				$GUI->tableAddCol($row, $os['alias']);
			else
				$GUI->tableAddCol($row, $os['name']);
			$GUI->tableAddCol($row, $os['text']);
		}
	}
	else
		$GUI->formAddDropdown($GUI->tableAddCol($row, "", 3), "image", $osDD);
	$GUI->formAddInputElement($form, "submit", "submit", _("reinstall"));
}
else
{
	$GUI->p(_("sorry your request could not be performed")."!");
	$GUI->p(_("please contact support")."!");
}
?>
