<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information;

require_once('AdminFactory.class.php');
require_once('VserverFactory.class.php');
require_once('NodeFactory.class.php');
require_once("Customer.class.php");
$ADMIN = AdminFactory::getInstance()->getUserByID($USERINFO['id']);

$nodename = $PARAMS[0];
$vservername = $PARAMS[1];
$node = NodeFactory::getNodeFactory()->getNodeByName($nodename);

$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, $node->getId());

require_once "navi.php";

if(@$PARAMS[2] == "submit") {
	$state = $vserver->getFullState();
	if($state[0] == "Online")
	{
		$GUI->div(_("stopping")." ".$vserver->getName()." ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$dmesg = $vserver->controlStop();
		$off = $vserver->getState();
		$off == "Offline" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
		$f = $GUI->fieldset("dmesg");
		foreach($dmesg as $msg)
			$GUI->p(nl2br($msg), $f);
		$GUI->br();
		$GUI->flushContent();
	}
	if($off == "Online")
		exit;
	
	if($state[1] == "rescue")
		$GUI->div(_("switching to normal system")." ".$vserver->getName()." ....", "left");
	else
		$GUI->div(_("switching to rescue system")." ".$vserver->getName()." ....", "left");
	$GUI->flushContent();
	sleep(5);
	$rescue = $vserver->setRescue();
	if($state[1] == "rescue")
		$rescue[0] == "Off" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
	else
		$rescue[0] == "On" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
	$GUI->flushContent();
	
	$GUI->div(_("starting")." ".$vserver->getName()." ....", "left");
	$GUI->flushContent();
	$dmesg = $vserver->controlStart();
	$on = $vserver->getState();
	$on == "Online" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
	$f = $GUI->fieldset("dmesg");
	foreach($dmesg as $msg)
		$GUI->p(nl2br($msg), $f);
	$GUI->br();
	$GUI->flushContent();
	
	$state = $vserver->getFullState();
	
	if($state[1] == "rescue") {
		$password = createPassword(8);
		$vserver->controlSetupPassword($password);
		$GUI->p(_("rescue root password for ssh is").": ".$password);
		$GUI->p(_("system is booted into rescue mode"));
	}
	else {
		$GUI->p(_("system is booted into normal mode"));	
	}
}
else {
	$state = $vserver->getFullState();
	$f = $GUI->fieldset(_("rescue mode"));
	
	if(isset($state[1]) && $state[1] == "rescue") {
		$GUI->p(_("vserver is in rescue mode"), $f);
		$form = $GUI->form($f, "iptables_list", (@$PARAMS[2] != "submit" ? $PARAMS[1] . "/submit" : "submit"));
		$GUI->formAddInputElement($form, "submit", "submit", _("boot into normal mode"));
	}
	else {
		$GUI->p(_("vserver is in normal mode"), $f);
		$form = $GUI->form($f, "iptables_list", (@$PARAMS[2] != "submit" ? $PARAMS[1] . "/submit" : "submit"));
		$GUI->formAddInputElement($form, "submit", "submit", _("boot into rescue mode"));
	}
}

?>
