<?php
/**
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */
$AUTH   =& OpenVCP::call('Auth', 'getReference');
$GUI    =& OpenVCP::call('GUI' , 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information;

require_once('VserverFactory.class.php');
require_once('NodeFactory.class.php');

$nodename = $PARAMS[0];
$vservername = $PARAMS[1];
$node = NodeFactory::getNodeFactory()->getNodeByName($nodename);

$vserver = VserverFactory::getInstance()->getVserverByNameAndNode($vservername, $node->getId());

$task = "states";

require_once("navi.php");

if($PARAMS[3] == "" && $PARAMS[2] == "traffic")
{
	OpenVCP::gotoURL("super/vservers/stats/".$node->getName()."/".$vserver->getName()."/traffic/day");
}

if(@isset($_POST['year']))
{
	$year = $_POST['year'];
	$month = $_POST['month'];
	$day = $_POST['day'];
}
else
{
	$year = date('Y');
	$month = date('n');
	$day = date('j');
}
if($PARAMS[2] == "traffic" && $vserver && $PARAMS[3] != "year")
{
	if($PARAMS[3] == "day")
	{
		$traffic = $vserver->getTrafficDay($day, $month, $year);
	}
	else if($PARAMS[3] == "month")
	{
		$traffic = $vserver->getTrafficMonth($month, $year);
	}

	$table = $GUI->table();
	$thead = $GUI->tableAddHead($table);

	if($PARAMS[2] == "day")
	$GUI->tableAddCol($thead, _("traffic for")." "._(date("F \\t\h\e jS", mktime(0, 0, 0, $month, $day, $year)))." ".$year, 5);
	else
	$GUI->tableAddCol($thead, _("traffic for")." "._(date("F", mktime(0, 0, 0, $month, 1, $year)))." ".$year, 5);

	$row = $GUI->tableAddRow($table);
	$GUI->img($GUI->tableAddCol($row, "", 5, "", "", "center"), $PARAMS[3] == "day" ? $node->getName() . "/" . $vserver->getName()."/day/".$month."/".$year."/".$day : $node->getName() . "/" . $vserver->getName()."/month/".$month."/".$year, false);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, $PARAMS[3] == "day" ? _("hour") : _("day"));
	$GUI->tableAddCol($row, _("ip"));
	$GUI->tableAddCol($row, _("traffic incoming"));
	$GUI->tableAddCol($row, _("traffic outgoing"));
	$GUI->tableAddCol($row, _("traffic total"));
	$in = 0;
	$out = 0;
	$total = 0;
	foreach($traffic as $key => $element)
	{
		foreach($element as $ip => $direction)
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, $key);
			$GUI->tableAddCol($row, $ip);
			$GUI->tableAddCol($row, number_format($direction['in']/1000/1000, 2)." MB");
			$in += $direction['in'];
			$GUI->tableAddCol($row, number_format($direction['out']/1000/1000, 2)." MB");
			$out += $direction['out'];
			$GUI->tableAddCol($row, number_format($direction['total']/1000/1000, 2)." MB");
			$total += $direction['total'];
		}
	}
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, "");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, _("sum").":");
	$GUI->tableAddCol($row, number_format($in/1000/1000/1000,2)." GB");
	$GUI->tableAddCol($row, number_format($out/1000/1000/1000,2)." GB");
	$GUI->tableAddCol($row, number_format($total/1000/1000/1000,2)." GB");
	$GUI->br();
	$form = $GUI->form(0, "traffic", $PARAMS[3] == "day" ? "day" : "month");
	$months = array();
	for($i = 1; $i <= date("t", mktime (0, 0, 0, $month)); $i++)
	{
		$days[$i] = $i;
	}
	for($i = 1; $i <= 12; $i++)
	{
		$months[_(date("F", mktime(0, 0, 0, $i, 1, date('Y'))))] = $i;
	}
	$years = array();
	for($i = date('Y'); $i >= 2005 ; $i--)
	{
		$years[$i] = $i;
	}
	if($PARAMS[3] == "day")
	{
		$GUI->formAddDropdown($form, "day", $days, $day);
	}
	$GUI->formAddDropdown($form, "month", $months, $month);
	$GUI->formAddDropdown($form, "year", $years, $year);
	$GUI->formAddInputElement($form, "submit", "submit", _("go"));
}
else if($PARAMS[2] == "traffic" && $vserver && $PARAMS[3] == "year")
{
	$table = $GUI->table();
	$row = $GUI->tableAddHead($table);
	$GUI->tableAddCol($row, _("traffic for")." ".$year, 5);
	$row = $GUI->tableAddRow($table);
	$GUI->img($GUI->tableAddCol($row, "", 5, "", "", "center"), $node->getName() . "/" . $vserver->getName()."/year/".$year, false);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("month"));
	$GUI->tableAddCol($row, _("traffic incoming"));
	$GUI->tableAddCol($row, _("traffic outgoing"));
	$GUI->tableAddCol($row, _("traffic total"));
	$traffic['in'] = 0;
	$traffic['out'] = 0;
	$traffic['total'] = 0;
	$trafficTotal = $vserver->getTrafficYear($year);
	foreach($trafficTotal as $month => $trafficRaw)
	{
		if($year < date('Y'))
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, _(date("F", mktime(0, 0, 0, $month, 1, 2006))));
			$GUI->tableAddCol($row, number_format($trafficRaw['in']/1000/1000/1000, 2)." GB");
			$GUI->tableAddCol($row, number_format($trafficRaw['out']/1000/1000/1000, 2)." GB");
			$GUI->tableAddCol($row, number_format($trafficRaw['total']/1000/1000/1000, 2)." GB");
		}
		else if($year == date('Y') && $month <= date('n'))
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, _(date("F", mktime(0, 0, 0, $month, 1, 2006))));
			$GUI->tableAddCol($row, number_format($trafficRaw['in']/1000/1000/1000, 2)." GB");
			$GUI->tableAddCol($row, number_format($trafficRaw['out']/1000/1000/1000, 2)." GB");
			$GUI->tableAddCol($row, number_format($trafficRaw['total']/1000/1000/1000, 2)." GB");
		}
		$traffic['in'] += number_format($trafficRaw['in']/1000/1000/1000, 2);
		$traffic['out'] += number_format($trafficRaw['out']/1000/1000/1000, 2);
		$traffic['total'] += number_format($trafficRaw['total']/1000/1000/1000, 2);
	}
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, "");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("sum").":");
	$GUI->tableAddCol($row, number_format($traffic['in'],2)." GB");
	$GUI->tableAddCol($row, number_format($traffic['out'],2)." GB");
	$GUI->tableAddCol($row, number_format($traffic['total'],2)." GB");
	$GUI->br();
	$form = $GUI->form(0, "traffic", "year");
	$years = array();
	for($i = date('Y'); $i >= 2005 ; $i--)
	{
		$years[$i] = $i;
	}
	$GUI->formAddDropdown($form, "year", $years, $year);
	$GUI->formAddInputElement($form, "submit", "submit", _("go"));
}
else if($PARAMS[2] == "resources")
{
	if(isset($_POST['submit']))
	{

		$resources = $vserver->getResourcesHour($_POST['day'], $_POST['month'], $_POST['year']);
		$urlString = "";
		foreach($_POST['res'] as $key => $value)
		{
			$urlString = $urlString . "/" . $value;
		}
		$table = $GUI->table();
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("ressources for")." ".$_POST['day']." "._(date("F", mktime(0, 0, 0, $_POST['month'], 1, $_POST['year'])))." ".$_POST['year'], 5);
		$row = $GUI->tableAddRow($table);
		$GUI->img($GUI->tableAddCol($row, "", count($_POST['res']), "", "", "center"), $node->getName() . "/" . $vserver->getName()."/resources/".$month."/".$year."/".$day.$urlString, false);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("hour"));
		foreach($_POST['res'] as $key => $value)
		{
			$GUI->tableAddCol($row, _($value));
		}
		foreach($resources as $hour => $values)
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, $hour);
			foreach($_POST['res'] as $key => $value)
			{
				$GUI->tableAddCol($row, $values[$value]);
			}
		}
	}
	else
	{
		$GUI->h(_("show resources"));
		$GUI->p(_("please select resources"));
		$form = $GUI->form(0, "resources", "resources/submit");
		$table = $GUI->table($form);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("number of processes"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[proc]", "proc", true);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("virtual memory"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[vm]", "vm", true);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("locked virtual memory"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[vml]", "vml");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("resident set size"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[rss]", "rss", true);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("anonymous memory size"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[anon]", "anon");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("number of files"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[files]", "files");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("number of open file descriptors"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[ofd]", "ofd");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("file locks held"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[locks]", "locks");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("number of open sockets"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[sock]", "sock");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("bytes in POSIX mqueues"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[msgq]", "msgq");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("shared memory size"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[shm]", "shm");
		$months = array();
		for($i = 1; $i <= date("t", mktime (0, 0, 0, $month)); $i++)
		{
			$days[$i] = $i;
		}
		for($i = 1; $i <= 12; $i++)
		{
			$months[_(date("F", mktime(0, 0, 0, $i, 1, date('Y'))))] = $i;
		}
		$years = array();
		for($i = date('Y'); $i >= 2005 ; $i--)
		{
			$years[$i] = $i;
		}
		$GUI->formAddDropdown($form, "day", $days, $day);
		$GUI->formAddDropdown($form, "month", $months, $month);
		$GUI->formAddDropdown($form, "year", $years, $year);
		$GUI->br($form);
		$GUI->formAddInputElement($form, "submit", "submit", "show");
	}
}
?>
