<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */

if($vserver->getAdmin() != $USERINFO['id'] && $AUTH->getPrivileges('see_admins') != 'y')
{
	OpenVCP::gotoURL("super/vservers");
}

$GUI->addContentMenuHead($vserver->getName(), 3, 1);
$GUI->addContentMenuSub("info/".$vserver->getNodeObject()->getName()."/".$vserver->getName(), _("info"), 2);
if($vserver->getUserObject()->getUsername() != "")
	$GUI->addContentMenuSub("gotou/".$vserver->getUserObject()->getUsername(), _("customer"),2);
$GUI->addContentMenuSub("goton/".$vserver->getNodeObject()->getName(), _("node"), 2);
$GUI->addContentMenuHead(_("Options"), 3, 2);
$GUI->addContentMenuSub("control/".$vserver->getNodeObject()->getName()."/".$vserver->getName(), _("control"), 3);
$GUI->addContentMenuSub("rescue/".$vserver->getNodeObject()->getName()."/".$vserver->getName(), _("rescue"), 3);
$GUI->addContentMenuSub("reinstall/".$vserver->getNodeObject()->getName()."/".$vserver->getName(), _("reinstall"), 3);
$GUI->addContentMenuSub("ips/".$vserver->getNodeObject()->getName()."/".$vserver->getName(), _("ips"), 3);
$GUI->addContentMenuSub("iptables/".$vserver->getNodeObject()->getName()."/".$vserver->getName(), _("iptables"), 3);
if(isset($task) && $task == "iptables")
{
	$GUI->addContentMenuSub("iptables/" . $vserver->getNodeObject()->getName()."/".$vserver->getName() . "/add", _("add rule"), 4);
}
$GUI->addContentMenuSub("bandwidth/".$vserver->getNodeObject()->getName()."/".$vserver->getName(), _("bandwidth"), 3);
if(isset($task) && $task == "bandwidth")
{
	$GUI->addContentMenuSub("bandwidth/" . $vserver->getNodeObject()->getName()."/".$vserver->getName() . "/add", _("add rule"), 4);
}
$GUI->addContentMenuSub("flags/".$vserver->getNodeObject()->getName()."/".$vserver->getName(), _("flags"), 3);
$GUI->addContentMenuSub("limits/".$vserver->getNodeObject()->getName()."/".$vserver->getName(), _("limits"), 3);
$GUI->addContentMenuSub("stats/".$vserver->getNodeObject()->getName()."/".$vserver->getName(), _("stats"), 3);
if(isset($task) && $task == "states")
{
	$GUI->addContentMenuSub("stats/".$vserver->getNodeObject()->getName()."/".$vserver->getName()."/traffic/day", _("traffic day"), 4);
	$GUI->addContentMenuSub("stats/".$vserver->getNodeObject()->getName()."/".$vserver->getName()."/traffic/month", _("traffic month"), 4);
	$GUI->addContentMenuSub("stats/".$vserver->getNodeObject()->getName()."/".$vserver->getName()."/traffic/year", _("traffic year"), 4);
	$GUI->addContentMenuSub("stats/".$vserver->getNodeObject()->getName()."/".$vserver->getName()."/resources", _("resources"), 4);
}
?>
