<?php
/**
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */
$AUTH   =& OpenVCP::call('Auth', 'getReference');
$GUI    =& OpenVCP::call('GUI' , 'getReference');
$XML    =& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$DB	=& OpenVCP::call('DB'  , 'getReference');
$LOG    =& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information;
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('user');

set_include_path(OPENVCP_ROOT_DIR."/core");
require_once("CustomerFactory.class.php");
require_once('AdminFactory.class.php');
require_once('VserverFactory.class.php');
$CUSTOMER = CustomerFactory::getInstance()->getUserByID($USERINFO['id']);
$ADMIN = AdminFactory::getInstance()->getUserByID($CUSTOMER->getAdminId());

$GUI->addContentMenuHead(_("control"));
$vservers = VserverFactory::getInstance()->getVServersOfUser($USERINFO['id']);
foreach($vservers as $vserver)
{
	$GUI->addContentMenuHead($vserver->getName(), 3, 1);
	$GUI->addContentMenuSub($vserver->getName()."/control", _("control"), 2);
	$GUI->addContentMenuSub($vserver->getName()."/rescue", _("rescue"), 2);
	$GUI->addContentMenuSub($vserver->getName()."/reinstall", _("reinstall"), 2);
	$GUI->addContentMenuSub($vserver->getName()."/hostname", _("hostname"), 2);
	$GUI->addContentMenuSub($vserver->getName()."/change", _("root password"), 2);
	$GUI->addContentMenuSub($vserver->getName()."/trafficlimit", _("trafficlimit"), 2);
}
if($PARAMS[0] != "debug" && isset($PARAMS[0])) {
	$vserver = VserverFactory::getInstance()->getVserverByNameAndUser($PARAMS[0], $USERINFO['id']);
}

if($PARAMS[0] != "" && $PARAMS[1] == "control")
{
	if($AUTH->getPrivileges('can_reset') != 'y')
	OpenVCP::gotoURL("user/denied/can_restart");

	if($vserver->isDisabled()) {
		$GUI->p(_("sorry this vserver is disabled"));
		exit();
	}

	$state = $vserver->getState();

	if($PARAMS[2] == "submit" && (isset($_POST['restart']) || isset($_POST['start']) || isset($_POST['stop'])) && $vserver != null)
	{
		$GUI->flushContent();
		if(isset($_POST['restart']) || isset($_POST['stop'])) {
			$LOG->logInfo(_("restarted vserver")." ".$PARAMS[0]);
			do {
				$GUI->div(_("stopping vserver")." ".$PARAMS[0]."...", "left");
				$GUI->flushContent();
				$dmesg = $vserver->controlStop();
				$state = $vserver->getState();
				if($state == "Offline") {
					$GUI->div(_("ok"), "rightgreen");
				}
				else {
					$GUI->div(_("failed"), "rightred");
				}
				$GUI->flushContent();
			} while ($state != "Offline");
			
			$f = $GUI->fieldset(_("output"), "dmesg");
			foreach($dmesg as $msg)
				foreach(explode('<br />', $msg) as $line) {
					$GUI->addToElementID($f, $line."<br />");
				}
		}
		else
			$LOG->logInfo(_("started vserver")." ".$PARAMS[0]);
		
		if(!isset($_POST['stop'])) 
		{
			if($state == "Offline")
			{
				$GUI->flushContent();
				$GUI->div(_("starting vserver")." ".$PARAMS[0]."...", "left");
				$GUI->flushContent();
				$GUI->flushContent();
				$dmesg = $vserver->controlStart();
				$state = $vserver->getState();
				if($state == "Online")
				{
					$GUI->div(_("ok"), "rightgreen");
					$f = $GUI->fieldset(_("output"), "dmesg");
					foreach($dmesg as $msg)
						foreach(explode('<br />', $msg) as $line) {
							$GUI->addToElementID($f, $line."<br />");
						}
					$GUI->p(_("vserver")." ".$PARAMS[0]." "._("sucessfully started"));
					$GUI->flushContent();
				}
				else
				{
					$GUI->div(_("failed"), "rightred");
					$f = $GUI->fieldset(_("output"), "dmesg");
					foreach($dmesg as $msg)
						foreach(explode('<br />', $msg) as $line) {
							$GUI->addToElementID($f, $line."<br />");
						}
					$GUI->p(_("error starting vserver")." ".$PARAMS[0]."!");
					$GUI->p(_("please contact support")."!");
					$GUI->flushContent();
					if(isset($_POST['restart']))
						$LOG->logError(_("restart of vserver failed: vserver doesn't start after stop'")." ".$PARAMS[0]);
					else
						$LOG->logError(_("start of vserver failed: vserver doesn't start'")." ".$PARAMS[0]);
				}
			}
			else
			{
				$GUI->div(_("failed"), "rightred");
				$GUI->p(_("error stopping vserver")." ".$PARAMS[0]."!");
				$GUI->p(_("please contact support")."!");
				$LOG->logError(_("reinstall of vserver failed: vserver didn't stop")." ".$PARAMS[0]);
				$GUI->flushContent();
			}
		}
	}
	else if($vserver != null)
	{
		$f = $GUI->fieldset(_("control vserver"));
		if($state == "Online") {
			$form = $GUI->form($f, "restart_vserver", "control/submit");
			$GUI->p(_("vserver")." ".$PARAM[0]." "._("is online")."!", $form);
			$GUI->p(_("should this veserver be restarted")."?", $form);
			$GUI->formAddInputElement($form, "submit", "restart", _("restart"));
			$GUI->p(_("should this veserver be stoped")."?", $form);
			$GUI->formAddInputElement($form, "submit", "stop", _("stop"));
		}
		else {
			$GUI->p(_("vserver")." ".$PARAM[0]." "._("is offline")."!", $f);
			$GUI->p(_("should this veserver be started")."?", $f);
			$form = $GUI->form($f, "start_vserver", "control/submit");
			$GUI->formAddInputElement($form, "submit", "start", _("start"));
		}
	}
	else
	{
		$GUI->p(_("sorry your request could not be performed")."!");
		$GUI->p(_("please contact support")."!");
	}

}
else if($PARAMS[0] != "" && $PARAMS[1] == "rescue")
{
        if($AUTH->getPrivileges('can_reset') != 'y')
	        OpenVCP::gotoURL("user/denied/can_restart");

	if($vserver->isDisabled()) {
		$GUI->p(_("sorry this vserver is disabled"));
		exit();
	}
	
	if($PARAMS[2] == "submit" && md5($_POST['currentuserpass']) == $USERINFO['password']) {
		
		$state = $vserver->getFullState();
		if($state[0] == "Online")
		{
			$GUI->div(_("stopping")." ".$vserver->getName()." ....", "left");
			$GUI->flushContent();
			$GUI->flushContent();
			$dmesg = $vserver->controlStop();
			$off = $vserver->getState();
			$off == "Offline" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
			$f = $GUI->fieldset(_("output"), "dmesg");
			foreach($dmesg as $msg)
				foreach(explode('<br />', $msg) as $line) {
					$GUI->addToElementID($f, $line."<br />");
				}
			$GUI->br();
			$GUI->flushContent();
		}
		if($off == "Online")
			exit;
		
		if($state[1] == "rescue")
			$GUI->div(_("switching to normal system")." ".$vserver->getName()." ....", "left");
		else
			$GUI->div(_("switching to rescue system")." ".$vserver->getName()." ....", "left");
		$GUI->flushContent();
		sleep(5);
		$rescue = $vserver->setRescue();
		if($state[1] == "rescue")
			$rescue[0] == "Off" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
		else
			$rescue[0] == "On" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
		$GUI->flushContent();
		
		$GUI->div(_("starting")." ".$vserver->getName()." ....", "left");
		$GUI->flushContent();
		$dmesg = $vserver->controlStart();
		$on = $vserver->getState();
		$on == "Online" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
		$f = $GUI->fieldset(_("output"), "dmesg");
		foreach($dmesg as $msg)
			foreach(explode('<br />', $msg) as $line) {
				$GUI->addToElementID($f, $line."<br />");
			}
		$GUI->br();
		$GUI->flushContent();
		
		$state = $vserver->getFullState();
		
		if($state[1] == "rescue") {
			$password = createPassword(8);
			$vserver->controlSetupPassword($password[0]);
			$GUI->p(_("rescue root password for ssh is").": ".$password[0]);
			$GUI->p(_("system is booted into rescue mode"));
			$GUI->p(_("your vserver can be found in /vserver"));
		}
		else {
			$GUI->p(_("system is booted into normal mode"));	
		}
	}
	else {
		$state = $vserver->getFullState();
		$f = $GUI->fieldset(_("rescue mode"));
		
		if($state[1] == "rescue") {
			$GUI->p(_("vserver is in rescue mode"), $f);
			$form = $GUI->form($f, "iptables_list", ($PARAMS[2] != "submit" ? $PARAMS[1] . "/submit" : "submit"));
			$div = $GUI->div("", null, $form);
			$GUI->addToElementID($div, _("current login pass").": ");
			$GUI->formAddInputElement($div, "password", "currentuserpass");
			$GUI->br($form);
			$GUI->formAddInputElement($form, "submit", "submit", _("boot into normal mode"));
		}
		else {
			$GUI->p(_("vserver is in normal mode"), $f);
			$form = $GUI->form($f, "iptables_list", ($PARAMS[2] != "submit" ? $PARAMS[1] . "/submit" : "submit"));
			$div = $GUI->div("", null, $form);
			$GUI->addToElementID($div, _("current login pass").": ");
			$GUI->formAddInputElement($div, "password", "currentuserpass");
			$GUI->br($form);
			$GUI->formAddInputElement($form, "submit", "submit", _("boot into rescue mode"));
		}
	}
}
else if($PARAMS[0] != "" && $PARAMS[1] == "reinstall")
{
	if($AUTH->getPrivileges('can_reinstall') != 'y')
		OpenVCP::gotoURL("user/denied/can_reinstall");

	if($vserver->isDisabled()) {
		$GUI->p(_("sorry this vserver is disabled"));
		exit();
	}

	if(($oslist = $CUSTOMER->getImages()) == null)
	{
		$osDD = $vserver->getNodeObject()->getImages();
	}
	else
	{
		foreach($oslist as $key=>$os) {

			if(is_numeric($key))
			$osDD[$os] = $os;
			else
			$osDD[$key] = $os;
		}
	}

	foreach($osDD as $key=>$value) $osDDn[htmlentities($key)] = htmlentities($value);
	$osDD = array_flip($osDDn);

	$_POST['image'] = htmlentities($_POST['image']);

	if($PARAMS[2] == "submit" && $vserver != null && isset($_POST['submit']) && in_array($_POST['image'], $osDD) && md5($_POST['currentuserpass']) == $USERINFO['password'])
	{
		
		$GUI->flushContent();
		$GUI->flushContent();
		$state = $vserver->getState();
		$offline = false;
		$LOG->logInfo(_("reinstalled vserver")." ".$PARAMS[0]." "._("with image")." ".$osDD[$_POST['image']]);

		if($state == "Offline")
		{
			$offline = true;
		}
		if($state == "Online")
		{
			$GUI->flushContent();
			$GUI->div(_("stopping vserver")." ".$PARAMS[0]."...", "left");
			$GUI->flushContent();
			$GUI->flushContent();
			$vserver->controlStop();
			sleep(2);
			$state = $vserver->getState();

			if($state == "Offline")
			{
				$GUI->div(_("ok"), "rightgreen");
				$GUI->flushContent();
				$GUI->flushContent();
				$offline = true;
			}
			else
			{
				$GUI->div(_("failed"), "rightred");
				$GUI->p(_("error starting vserver")." ".$PARAMS[0]."!");
				$GUI->p(_("please contact support")."!");
				$GUI->flushContent();
				$GUI->flushContent();
				$offline = false;
				$LOG->logError(_("reinstall of vserver failed: vserver didn't stop")." ".$PARAMS[0]);
			}
			$GUI->flushContent();
		}
		if($offline)
		{
			$GUI->div(_("reinstall vserver")." ".$PARAMS[0]."...", "left");
			$GUI->flushContent();
			$GUI->flushContent();
			sleep(1);
			$result = $vserver->controlSetupImage($_POST['image']);
			if($result == 1)
			{
				$GUI->div(_("ok"), "rightgreen");
				$GUI->div(_("starting vserver")." ".$PARAMS[0]."...", "left");
				$GUI->flushContent();
				$GUI->flushContent();
				$vserver->controlStart();
				$GUI->flushContent();
				$GUI->flushContent();
				$state = $vserver->getState();
				if($state == "Online")
				{
					$GUI->div(_("ok"), "rightgreen");
					$GUI->flushContent();
					$password = createPassword(8);
					$GUI->div(_("setting rootpassword")." ".$PARAMS[0]."...", "left");
					$GUI->flushContent();
					$vserver->controlSetupPassword($password[0]);
					$GUI->div(_("ok"), "rightgreen");
					$GUI->p(_("vserver")." ".$PARAMS[0]." "._("sucessfully reinstalled"));
					$GUI->p(_("new root password is").": ".$password[0]);
				}
				else
				{
					$GUI->div(_("failed"), "rightred");
					$GUI->p(_("error starting vserver")." ".$PARAMS[0]."!");
					$GUI->p(_("please contact support")."!");
					$GUI->flushContent();
					$LOG->logError(_("restart of vserver failed: vserver doesn't start after reinstall'")." ".$PARAMS[0]);

				}
			}
			else
			{
				$GUI->div(_("failed"), "rightred");
				$GUI->p(_("error reinstalling vserver")." ".$PARAMS[0]."!");
				$GUI->p(_("please contact support")."!");
				$GUI->flushContent();
			}
		}
		else
		{
			$GUI->p(_("sorry your request could not be performed")."!");
			$GUI->p(_("please contact support")."!");
			$GUI->flushContent();
		}
	}
	else if($vserver != null && !isset($_POST['submit']))
	{

		$f = $GUI->fieldset(_("reinstall vserver"));
		$form = $GUI->form($f, "vserver_reinstall", "reinstall/submit");
		$table = $GUI->table($form);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("available images"),2);
		if($oslist != null) {
			$images = $ADMIN->getImagesExtended();
			foreach($images as $os) {
				$row = $GUI->tableAddRow($table);
				$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "radio", "image", $os['name']);
				if($os['alias'] != '')
					$GUI->tableAddCol($row, $os['alias']);
				else
					$GUI->tableAddCol($row, $os['name']);
				$GUI->tableAddCol($row, $os['text']);
			}
		}
		else
		$GUI->formAddDropdown($GUI->tableAddCol($row, "", 3), "image", $osDD);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("current login pass").":", 2);
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "currentuserpass");
		$GUI->formAddInputElement($form, "submit", "submit", _("reinstall"));
	}
	else
	{
		$GUI->p(_("sorry your request could not be performed")."!");
		$GUI->p(_("did you insert your password")."?");
		$GUI->p(_("please contact support")."!");
	}
}
else if($PARAMS[0] != "" && $PARAMS[1] == "trafficlimit")
{
	if($vserver->isDisabled()) {
		$GUI->p(_("sorry this vserver is disabled"));
		exit();
	}
	
	$GUI->title(_("setting traffliclimits for vserver")." ".$PARAMS[0]);
	if($PARAMS[2] == "submit" && isset($_POST['submit']))
	{
		
		if(md5($_POST['currentuserpass']) == $USERINFO['password'])
		{
			if($_POST['limit_soft'] != "")
				$vserver->setTrafficLimit($_POST['limit_soft'], $USERINFO['email'], 'soft');
			if($_POST['limit_hard'] != "")
				$vserver->setTrafficLimit($_POST['limit_hard'], $USERINFO['email'], 'hard');
			$GUI->p(_("trafficlimit set"));
			$LOG->logInfo(_("changed hard trafficlimit of vserver")." ".$PARAMS[0]);
		}
		else
		{
			$GUI->p(_("current login passwords doesn't match"));
		}
	}
	if($PARAMS[2] == "submit" && isset($_POST['reset']))
	{
		if(md5($_POST['currentuserpass']) == $USERINFO['password'])
		{
			$vserver->delTrafficLimit('soft');
			$vserver->delTrafficLimit('hard');
			$GUI->p(_("trafficlimit deleted"));
			$LOG->logInfo(_("changed hard trafficlimit of vserver")." ".$PARAMS[0]);
		}
		else
		{
			$GUI->p(_("current login passwords doesn't match"));
		}
	}
	
	$trafficlimits = $vserver->getTrafficLimit();
	while($limit = $XML->getNextStruct($trafficlimits)) {
		if($limit['type'] == 'soft')
			$softlimits = $limit;
		if($limit['type'] == 'hard')
			$hardlimits = $limit;
	}

	$f = $GUI->fieldset(_("change hard trafficlimit"));
	$form = $GUI->form($f, "change_hard_trafficlimit", ($PARAMS[2] == "submit" ? "submit" : "trafficlimit/submit"));
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("soft limit")." [MB]: ");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "input", "limit_soft", $softlimits['total']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("hard limit")." [MB]: ");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "input", "limit_hard", $hardlimits['total']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("current login pass").": ");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "currentuserpass");
	$GUI->formAddInputElement($form, "submit", "submit", _("add/change"));
	$GUI->formAddInputElement($form, "submit", "reset", _("delete"));
	
	$GUI->p(_("when the vserver hits the given traffic limit it will be automatically shut down and you will receive an email"));

	$GUI->p(_("mails will be sent to")." ".($softlimits['notify'] != "" ? $softlimits['notify'] : ($hardlimits['notify'] != "" ? $hardlimits['notify'] : $USERINFO['email'])));
}
else if($PARAMS[0] != "" && $PARAMS[1] == "change")
{
	if($AUTH->getPrivileges('can_reset') != 'y')
		OpenVCP::gotoURL("user/denied/can_change_admin_pass");
	
	if($vserver->isDisabled()) {
		$GUI->p(_("sorry this vserver is disabled"));
		exit();
	}
	
	if($vserver->getState() != "Online") {
		$GUI->p(_("sorry vserver is offline"));
		$GUI->p(_("operation not permitted"));
		exit();
	}
	
	$GUI->title(_("changing root password of")." ".$PARAMS[0]);
	if($PARAMS[2] == "submit" && isset($_POST['submit']))
	{
		
		if(md5($_POST['currentuserpass']) == $USERINFO['password'])
		{
			if($vserver->controlSetupPassword($_POST['newrootpass']) == 1) {
				$GUI->p(_("password successfully changed"));
				$LOG->logInfo(_("changed root password of vserver")." ".$PARAMS[0]);
			}
			else {
				$GUI->p(_("error setting new rootpassword"));
			}
		}
		else
		{
			$GUI->p(_("current login pass doesn't match"));
		}
	}

	$f = $GUI->fieldset(_("change root password"));
	$form = $GUI->form($f, "change_root_password", ($PARAMS[1] == "submit" ? "submit" : "change/submit"));
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("new root password").":");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "input", "newrootpass");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("current login pass").":");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "currentuserpass");
	$GUI->formAddInputElement($form, "submit", "submit", _("set"));
}
else if($PARAMS[0] != "" && $PARAMS[1] == "hostname")
{	
	if($vserver->isDisabled()) {
		$GUI->p(_("sorry this vserver is disabled"));
		exit();
	}	
	
	$GUI->title(_("change hostname of")." ".$PARAMS[0]);
	if($PARAMS[2] == "submit" && isset($_POST['submit']))
	{
		if(md5($_POST['currentuserpass']) == $USERINFO['password'])
		{
			$vserver->setHostname($_POST['hostname']);
			$GUI->p(_("hostname successfully changed"));
			$GUI->p(_("you have to restart your vserver in order to complete the change"));
			$LOG->logInfo(_("chanched hostname of vserver")." ".$PARAMS[0]);
		}
		else
		{
			$GUI->p(_("current login pass doesn't match"));
		}
	}
	$f = $GUI->fieldset(_("change hostname"));
	$form = $GUI->form($f, "change_hostname", ($PARAMS[2] == "submit" ? "submit" : "hostname/submit"));
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("current hostname").":");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "input", "hostname", $vserver->getHostname());
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("current login pass").":");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "currentuserpass");
	$GUI->formAddInputElement($form, "submit", "submit", _("set"));
}
else
{
	$table = $GUI->table($GUI->fieldset(_("vserver")));
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);

	$GUI->tableAddCol($row, _("name"), 1);
	$GUI->tableAddCol($row, _("state"), 1);
	$GUI->tableAddCol($row, _("load"), 1);
	$GUI->tableAddCol($row, _("uptime"), 1);

	foreach($vservers as $vs)
	{
		$row = $GUI->tableAddRow($table);
		$row = $GUI->tableAddCol($row, $vs->getName());
		$GUI->img($GUI->tableAddCol($row, ""), ($vs->getState() == "Online") ? "green.png" : "red.png", true, ($vs->getState() == "Online") ? _("online") : _("offline"), 15, 15);
		$GUI->tableAddCol($row, $vs->getLoad(true));
		$GUI->tableAddCol($row, $vs->getUptime(true));
	}
}
?>
