<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner/ OpenVCP Team
 * @version 0.4.0.1
 * @package OpenVCP-v0.4
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = $AUTH->user_information;


$GUI->addContentMenu("", _("overview"));
$GUI->addContentMenu("logout", _("logout"));
$GUI->addContentMenuSpace();

set_include_path(OPENVCP_ROOT_DIR."/core");
require_once("CustomerFactory.class.php");
require_once('AdminFactory.class.php');
require_once('VserverFactory.class.php');
$CUSTOMER = CustomerFactory::getInstance()->getUserByID($USERINFO['id']);
$ADMIN = AdminFactory::getInstance()->getUserByID($CUSTOMER->getAdminId());

$GUI->addContentMenuHead(_("vserver"));
$vservers = VserverFactory::getInstance()->getVServersOfUser($CUSTOMER->getId());
foreach($vservers as $vserver)
{
	$GUI->addContentMenuSub($vserver->getName(), $vserver->getName(), 1);
}


if(in_array('denied', $PARAMS))
{
	$GUI->p(_("Access denied"));
	$GUI->p(_("Missing Privilege: ").$PARAMS[1]);
}
else if(in_array('logout', $PARAMS))
{
	$AUTH->close_session();
}
else if($PARAMS[0] != "")
{
	$vserver = VserverFactory::getInstance()->getVserverByNameAndUser($PARAMS[0], $CUSTOMER->getId());
	$table = $GUI->table();
	$GUI->h(_("vServer data"), 2, $GUI->tableAddCol($GUI->tableAddRow($table), "", 2));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("vserver name"));
	$GUI->tableAddCol($row, $vserver->getName());
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("state"));
	//state
	if($vserver->getState() == "Online")
	{
		$GUI->tableAddCol($row, _("online"));
	}
	else
	{
		$GUI->tableAddCol($row, _("offline"));
	}
	//uptime
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("uptime"));
	$GUI->tableAddCol($row, $vserver->getUptime(true));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("current load"));
	$GUI->tableAddCol($row, $vserver->getLoad(true)); 
	//IPs
	$response = $vserver->getIps();
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("ip's"));
	$ips = "";
	while(($ip = $XML->getNextStruct($response)) != NULL)
	{
		$ips .= $ip['ip']."<br>";
	}
	$GUI->tableAddCol($row, $ips);
	//Traffic
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("traffic"));
	$traffic = $vserver->getTrafficTotal(date('n'), date('Y'));
	$GUI->tableAddCol($row, number_format($traffic['total']/1000/1000/1000, 2)." GB");
	//space
	$struct = $vserver->getSpace();
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("space total"));
	$GUI->tableAddCol($row, $struct['total'] <= 0 ? _("n/a") : number_format($struct['total']/1024,2)." MB");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("space used"));
	$GUI->tableAddCol($row, $struct['used'] == -1 ? _("n/a") : number_format($struct['used']/1024,2)." MB");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("space free"));
	$GUI->tableAddCol($row, $struct['free'] == -1 ? _("n/a") : number_format(($struct['total'] - $struct['used'])/1024,2)." MB");

}
else
{
	$f = $GUI->fieldset(_("overview"));
	$table = $GUI->table($f);
	$GUI->h(_("customer data"), 2, $GUI->tableAddCol($GUI->tableAddRow($table), "", 2));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("company").":");
	$GUI->tableAddCol($row, $USERINFO['company']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("firstname").":");
	$GUI->tableAddCol($row, $USERINFO['firstname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("lastname").":");
	$GUI->tableAddCol($row, $USERINFO['lastname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("adress"));
	$GUI->tableAddCol($row, $USERINFO['street']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("postcode"));
	$GUI->tableAddCol($row, $USERINFO['postcode']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("city"));
	$GUI->tableAddCol($row, $USERINFO['city']);	
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("email"));
	$GUI->tableAddCol($row, $USERINFO['email']);	
}
?>
